# CBpanel "Launcher" plugin

name = "Launcher"
description = """Custom application launcher."""

import CBpanel, gtk, gobject, os

class Plugin(CBpanel.Plugin):
    def __init__(self, panel, settings):
        CBpanel.Plugin.__init__(self, panel, settings)
        self.set_border_width(0)

        for launcher in panel.launch_list:
            btn = gtk.Button()
            #~ btn.set_name("EdgeButton")
            btn.set_relief(gtk.RELIEF_NONE)
            btn.set_border_width(0)
            btn.set_focus_on_click(False)
            btn.set_property('can-focus', False)
            self.add(btn)
            try:
                img = panel.get_image_from_file(launcher[1])
            except:
                self.logWARNING("can't create launcher => %s" %  launcher[0])
            if img:
                btn.add(img)
                #~ CBpanel.tooltips.set_tip(btn, launcher[2])
                btn.connect("clicked", self.onClicked, launcher[0])
        self.show_all()

    def onClicked(self, btn, cmd):
        cmd = "cd && %s" % cmd
        os.spawnl(os.P_NOWAIT, "/bin/sh", "/bin/sh", "-c", cmd)
